#Rotate a protein structure around a reference structure

#This tool rotate a protein structure with reference to another one. 
#The radius of the rotation is established by the initial distance between the two structures. If change to the radius magnitude is needed, first we need to change the distance between the two protein structures. 
#Usage: ./rotatepdb_pqr.sh {file1} {file2} {angle}
#file 1 is the reference structure. file2 is the structure to be rotated. The structures must be in pdb or pqr format.
#angle is the desired rotation angle in degrees. A positive angle will give counterclockwise rotation. 
#The output will have the form of: 
#
#             "  rot_{angle}_{file2}  " 
#
#The script " masscentpdb_pqr.sh " MUST be in the same folder as this tool.
#


if [ $# != 3 ]
then
        echo "can't run, it need parameter... "
        echo 'Usage: ./rotatepdb_pqr.sh file1 file2 ang '
        exit
fi

file1=$1
file2=$2
ang=$( echo $3*3.1415926/180 | bc -l  ) 

x1=$(./masscentpdb_pqr.sh $1 |awk '{print $1}')
y1=$(./masscentpdb_pqr.sh $1 |awk '{print $2}')
z1=$(./masscentpdb_pqr.sh $1 |awk '{print $3}')

awk -v A=${ang} -v xi=${x1} -v yi=${y1} -v zi=${z1} '{if($1=="ATOM") { { x=substr($0,31,8);y=substr($0,39,8);z=substr($0,47,8) } { xo=(x-xi);yo=(y-yi);zo=(z-zi) } { xn=(xo*cos(A))-(yo*sin(A))+xi;yn=(xo*sin(A))+(yo*cos(A))+yi } { printf("%s%8.3f%8.3f%8.3f%s\n",substr($0,1,30),xn,yn,z,substr($0,55,100))} } else print $0 }; ' $2 > rot_$3_${file2} 
