#Rotation of a protein structure around its center of mass (Pivot in z-axis) 

#This tool rotates a protein structure around its own center of mass using the z-axis as the rotation
#Usage: ./spinzpdb_pqr.sh {file1} {angle}
#file1 is the strucutre to be rotates. The structure must be in pdb or pqr format. 
#angle is the desired rotation angle in degrees/ A positive angle will give counterclockwise rotation.
#The output will have the form of:
#
#             "  spinz_{angle}_{file1}  "
#
#The script " masscentpdb_pqr.sh " must be in the same folder as this tool.
#

if [ $# != 2 ]
then
        echo "can't run, it need parameter... "
        echo "Usage: ./spinzpdb.sh file ang "
        exit
fi


file=$1
ang=$( echo $2*3.1415926/180 | bc -l  )

xo=$(./masscentpdb_pqr.sh $1 |awk '{print $1}')
yo=$(./masscentpdb_pqr.sh $1 |awk '{print $2}')
zo=$(./masscentpdb_pqr.sh $1 |awk '{print $3}')

awk -v A=${ang} -v xo=${xo} -v yo=${yo} -v zo=${zo} '{if($1=="ATOM") { x=substr($0,31,8);y=substr($0,39,8);z=substr($0,47,8);dx=x-xo;dy=y-yo;dz=z-zo;xn=(dx*cos(A))-(dy*sin(A))+xo;yn=(dx*sin(A))+(dy*cos(A))+yo;printf("%s%8.3f%8.3f%8.3f%s\n",substr($0,1,30),xn,yn,substr($0,47,8),substr($0,55,100))} else print $0 }; ' $1 > spinz_${2}_${file} 

