#Calculate center of mass of a protein structure

# This tool is used to calculate the center of mass of a protein structure.
#
# Usage: ./masscentpdb_pqr.sh file1
#file 1 is the proten structure, either in pdb or pqr format. 
#the output will have the form of:
#
#             "  (x_coordinate) (y_coordinate) (z_coordinate)  " 
#

if [ $# -lt 1 ]
then
        echo "can't run, it need parameter... "
	echo "# Usage: ./masscenter.sh file "
        exit
fi

#Current Atoms: C, N, O, S. 

awk -v num=0 -v sumx=0 -v sumy=0 -v sumz=0 -v num=0 -v mt=0 ' { ATOM=substr($0,14,1) } { if(ATOM=="C") { mn=12.0107 } else if(ATOM=="N") { mn=14.0067 } else if(ATOM=="O") { mn=15.9994 } else if(ATOM=="S") { mn=32.065 } else { mn=1.008 } } {if($1=="ATOM" || $1=="HETATM") {xn=substr($0,31,8);yn=substr($0,39,8);zn=substr($0,47,8);mt=mt+mn;sumx=sumx+(xn*mn);sumy=sumy+(yn*mn);sumz=sumz+(zn*mn);num=num+1 } } END {print sumx/mt,sumy/mt,sumz/mt} ' $1


